package cn.iocoder.yudao.module.member.service.storegoodsinventoryrecord;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.module.member.controller.admin.storegoodsinventoryrecord.vo.StoreGoodsInventoryRecordPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.storegoodsinventoryrecord.vo.StoreGoodsInventoryRecordSaveReqVO;
import cn.iocoder.yudao.module.member.dal.dataobject.storegoodsinventoryrecord.StoreGoodsInventoryRecordDO;
import cn.iocoder.yudao.module.member.dal.mysql.storegoodsinventoryrecord.StoreGoodsInventoryRecordMapper;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.member.enums.ErrorCodeConstants.STORE_GOODS_INVENTORY_RECORD_NOT_EXISTS;

/**
 * 商品出入库记录 Service 实现类
 *
 * @author 管理员
 */
@Service
@Validated
public class StoreGoodsInventoryRecordServiceImpl implements StoreGoodsInventoryRecordService {

    @Resource
    private StoreGoodsInventoryRecordMapper storeGoodsInventoryRecordMapper;

    @Override
    public Integer createStoreGoodsInventoryRecord(StoreGoodsInventoryRecordSaveReqVO createReqVO) {
        // 插入
        StoreGoodsInventoryRecordDO storeGoodsInventoryRecord = BeanUtils.toBean(createReqVO, StoreGoodsInventoryRecordDO.class);
        storeGoodsInventoryRecordMapper.insert(storeGoodsInventoryRecord);
        // 返回
        return storeGoodsInventoryRecord.getId();
    }

    @Override
    public void updateStoreGoodsInventoryRecord(StoreGoodsInventoryRecordSaveReqVO updateReqVO) {
        // 校验存在
        validateStoreGoodsInventoryRecordExists(updateReqVO.getId());
        // 更新
        StoreGoodsInventoryRecordDO updateObj = BeanUtils.toBean(updateReqVO, StoreGoodsInventoryRecordDO.class);
        storeGoodsInventoryRecordMapper.updateById(updateObj);
    }

    @Override
    public void deleteStoreGoodsInventoryRecord(Integer id) {
        // 校验存在
        validateStoreGoodsInventoryRecordExists(id);
        // 删除
        storeGoodsInventoryRecordMapper.deleteById(id);
    }

    private void validateStoreGoodsInventoryRecordExists(Integer id) {
        if (storeGoodsInventoryRecordMapper.selectById(id) == null) {
            throw exception(STORE_GOODS_INVENTORY_RECORD_NOT_EXISTS);
        }
    }

    @Override
    public StoreGoodsInventoryRecordDO getStoreGoodsInventoryRecord(Integer id) {
        return storeGoodsInventoryRecordMapper.selectById(id);
    }

    @Override
    public PageResult<StoreGoodsInventoryRecordDO> getStoreGoodsInventoryRecordPage(StoreGoodsInventoryRecordPageReqVO pageReqVO) {
        return storeGoodsInventoryRecordMapper.selectPage(pageReqVO);
    }


}